<?php

namespace App\Admin\Controllers;

use App\Models\ChatList;
use Dcat\Admin\Form;
use Dcat\Admin\Grid;
use Dcat\Admin\Show;
use Dcat\Admin\Http\Controllers\AdminController;

class ChatListController extends AdminController
{
    /**
     * Make a grid builder.
     *
     * @return Grid
     */
    protected function grid()
    {
        return Grid::make(new ChatList(), function (Grid $grid) {
            $grid->column('id')->sortable();
            $grid->column('user_id');
            $grid->column('to_user_id');
            $grid->column('last_msg');
            $grid->column('last_time');
            $grid->column('atime');
            $grid->column('un_read');
        
            $grid->filter(function (Grid\Filter $filter) {
                $filter->equal('id');
        
            });
        });
    }

    /**
     * Make a show builder.
     *
     * @param mixed $id
     *
     * @return Show
     */
    protected function detail($id)
    {
        return Show::make($id, new ChatList(), function (Show $show) {
            $show->field('id');
            $show->field('user_id');
            $show->field('to_user_id');
            $show->field('last_msg');
            $show->field('last_time');
            $show->field('atime');
            $show->field('un_read');
        });
    }

    /**
     * Make a form builder.
     *
     * @return Form
     */
    protected function form()
    {
        return Form::make(new ChatList(), function (Form $form) {
            $form->display('id');
            $form->text('user_id');
            $form->text('to_user_id');
            $form->text('last_msg');
            $form->text('last_time');
            $form->text('atime');
            $form->text('un_read');
        });
    }
}
